/*
** Module   : SocketEvents.java
** Abstract : A class for handling the EventList for socket and server-socket
**            case.
**
** Copyright (c) 2013, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- -----------------------Description------------------------
** 001 CS  20130204 Created initial version.
** 002 CS  20130218 Implement runtime socket support.
*/

package com.goldencode.p2j.util;

import com.goldencode.p2j.ui.CommonFrame;
import com.goldencode.p2j.ui.EventList;
/**
 * Class for handling socket and server-socket events
 */
public class SocketEvents
{
   /**
    * Waits for specified list of events.Sockets implementation
    * <p>
    * This method corresponds to the Progress statement: <br>
    * <b>WAIT-FOR </b>
    * 
    * @param    el
    *           List of events to wait for or <code>null</code> for the 
    *           default.
    */
   public static void waitFor(EventList el)
   {
      // TODO implement logic of WAIT-FOR for SOCKET and SERVER-SOCKET events.
   }
   /**
    * 
    * @param socket
    *        The accepted connection socket.
    * @param responseProcedure
    *        The response procedure name.
    * @param contextHandle
    *        The procedure context handle.
    */
   public static void registerEvent(java.net.Socket socket, String responseProcedure, handle contextHandle)
   {
      // create socket handle, to be passed as argument 
      Socket s = new SocketImpl(socket);
      
      // registerEvent logic placeholder
      // TODO implement actual code.
      ControlFlowOps.invokeIn(responseProcedure,
                              contextHandle,
                              new handle(s));
   }
}
